' Eckpunktproblem
' (c) 2001 by Andreas Meile
' Unter Anwendung von Algorithmen aus MiniCAD fr die geometrischen
' Berechnungen

DEFDBL A-Z

DECLARE SUB BestimmeSchnittpunktLinieLinie (x1#, y1#, x2#, y2#, x3#, y3#, x4#, y4#, xs#, ys#, f%)
DECLARE SUB BestimmeSchnittpunktKreisKreis (x1#, y1#, r12#, x2#, y2#, r22#, xs1#, ys1#, xs2#, ys2#, f%)
DECLARE SUB VerschiebeParallel (x1#, y1#, x2#, y2#, a#, xp1#, yp1#, xp2#, yp2#)
DECLARE FUNCTION d2e$ (w#)

INPUT "Radius R"; Ra#
INPUT "Radius r"; Ri#
INPUT "Lnge Werkstcktrger"; l#
INPUT "Breite Werkstcktrger"; b#
INPUT "Mittelpunkt grosser Radius"; mx#, my#
INPUT "Auflsung (Anzahl Linien-1)"; n%
INPUT "Layer"; la$
INPUT "Ausgabedatei"; d$

a# = l# - 2# * Ri#
hr# = b# - Ri#
Rr# = Ra# - Ri#

DIM xk#(n%), yk#(n%)

' Berechnen und als .DXF speichern

OPEN d$ + ".DXF" FOR OUTPUT AS 1
PRINT #1, 0
PRINT #1, "SECTION"
PRINT #1, 2
PRINT #1, "ENTITIES"
PRINT #1, 0
PRINT #1, "POLYLINE"
PRINT #1, 8
PRINT #1, la$
PRINT #1, 66
PRINT #1, "    1"
' PRINT #1, 70
' PRINT #1, "    0"

FOR i% = n% TO 0 STEP -1
  px1# = -a# * CDBL(i%) / CDBL(n%)
  py1# = Rr#
  BestimmeSchnittpunktKreisKreis px1#, py1#, a# * a#, 0#, 0#, Rr# * Rr#, px2#, py2#, fremdX#, fremdY#, d%
  VerschiebeParallel px2#, py2#, px1#, py1#, hr#, lx1#, ly1#, lx2#, ly2#
  IF i% = n% THEN
    ' Erster Punkt: Endpunkt
    xk#(i%) = lx2#
    yk#(i%) = ly2#
  ELSE
    BestimmeSchnittpunktLinieLinie lx1#, ly1#, lx2#, ly2#, alx1#, aly1#, alx2#, aly2#, xk#(i%), yk#(i%), a%
  END IF
  ' Punkt in Datei schreiben
  PRINT #1, 0
  PRINT #1, "VERTEX"
  PRINT #1, 8
  PRINT #1, la$
  PRINT #1, 10
  PRINT #1, d2e$(mx# + xk#(i%))
  PRINT #1, 20
  PRINT #1, d2e$(my# + yk#(i%))
  alx1# = lx1#
  aly1# = ly1#
  alx2# = lx2#
  aly2# = ly2#
NEXT i%
' Mittelpunkt als Abschluss
xe# = (lx1# + lx2#) / 2#
ye# = (ly1# + ly2#) / 2#
PRINT #1, 0
PRINT #1, "VERTEX"
PRINT #1, 8
PRINT #1, la$
PRINT #1, 10
PRINT #1, d2e$(mx# + xe#)
PRINT #1, 20
PRINT #1, d2e$(my# + ye#)
' Bogen: Ausbuchtung berechnen
b# = (SQR(2# * (xe# * xe# + ye# * ye#)) - xe# - ye#) / (xe# - ye#)
PRINT #1, 42
PRINT #1, d2e$(b#)
' Endpunkt
PRINT #1, 0
PRINT #1, "VERTEX"
PRINT #1, 8
PRINT #1, la$
PRINT #1, 10
PRINT #1, d2e$(mx# + ye#)
PRINT #1, 20
PRINT #1, d2e$(my# + xe#)
' 45 gespiegelte Version erzeugen: Umgekehrte Werte
FOR i% = 0 TO n%
  PRINT #1, 0
  PRINT #1, "VERTEX"
  PRINT #1, 8
  PRINT #1, la$
  PRINT #1, 10
  PRINT #1, d2e$(mx# + yk#(i%))
  PRINT #1, 20
  PRINT #1, d2e$(my# + xk#(i%))
NEXT i%
' Abschluss Polylinie
PRINT #1, 0
PRINT #1, "SEQEND"
PRINT #1, 8
PRINT #1, la$
' Abschluss DXF-Datei
PRINT #1, 0
PRINT #1, "ENDSEC"
PRINT #1, 0
PRINT #1, "EOF"
CLOSE 1

SYSTEM

SUB BestimmeSchnittpunktKreisKreis (x1, y1, r12, x2, y2, r22, xs1, ys1, xs2, ys2, f%) STATIC
  dx = x2 - x1
  dy = y2 - y1
  a2 = dx * dx + dy * dy
  f% = a2 <= LTol2
  IF NOT f% THEN
    a = SQR(a2)
    y = (a2 + r12 - r22) / 2# / a
    xk = dx / a
    yk = dy / a
    xh = x1 + xk * y
    yh = y1 + yk * y
    b2 = r12 - y * y
    f% = b2 < 0#
    IF ABS(b2) <= 2# * r1 * RuFe THEN
      xs1 = xh
      ys1 = yh
      f% = 1
    ELSEIF NOT f% THEN
      b = SQR(b2)
      xl = xk * b
      yl = yk * b
      xs1 = xh - yl
      ys1 = yh + xl
      xs2 = xh + yl
      ys2 = yh - xl
    END IF
  END IF
END SUB

SUB BestimmeSchnittpunktLinieLinie (x1, y1, x2, y2, x3, y3, x4, y4, xs, ys, f%) STATIC
  IF x1 = x2 THEN
    xh1 = x1: yh1 = y1
    xh2 = x3: yh2 = y3
    dx1 = 0#: dy1 = y2 - y1
    dx2 = x4 - x3: dy2 = y4 - y3
  ELSE
    xh1 = x3: yh1 = y3
    xh2 = x1: yh2 = y1
    dx1 = x4 - x3: dy1 = y4 - y3
    dx2 = x2 - x1: dy2 = y2 - y1
  END IF
  IF dx1 = 0# THEN
    f% = dx2 = 0#
    IF NOT f% THEN
      xs = xh1
      ys = yh2 + (xs - xh2) * dy2 / dx2
    END IF
  ELSE
    s1 = dy1 / dx1
    s2 = dy2 / dx2
    f% = ABS(s1 - s2) <= (1# + s1 * s2) * RuFe
    IF NOT f% THEN
      yh3 = yh1 - s1 * xh1
      yh4 = yh2 - s2 * xh2
      xs = (yh4 - yh3) / (s1 - s2)
      ys = yh3 + s1 * xs
    END IF
  END IF
END SUB

FUNCTION d2e$ (w#)
  h$ = STR$(w#)
  p% = INSTR(h$, "D")
  IF p% > 0 THEN
    MID$(h$, p%) = ""
  END IF
  d2e$ = h$
END FUNCTION

SUB VerschiebeParallel (x1, y1, x2, y2, a, xp1, yp1, xp2, yp2) STATIC
  dx = x2 - x1
  dy = y2 - y1
  a1 = SQR(dx * dx + dy * dy)
  w1 = dy * a / a1
  w2 = dx * a / a1
  xp1 = x1 - w1
  yp1 = y1 + w2
  xp2 = x2 - w1
  yp2 = y2 + w2
END SUB

